#include <stdio.h>
#include <stdlib.h>

#define MAPSIZE		(256 * (31 + 11) * 2)

int hex2digit(char *ptr)
{
	int	ret = 0;

	while (*ptr) {
		ret <<= 4;
		if (*ptr >= '0' && *ptr <= '9') {
			ret += *ptr - '0';
		} else if (*ptr >= 'A' && *ptr <= 'F') {
			ret += *ptr - 'A' + 10;
		} else if (*ptr >= 'a' && *ptr <= 'f') {
			ret += *ptr - 'a' + 10;
		} else {
			return 0;
		}
		ptr++;
	}

	return ret;
}

int main()
{
	int				i;
	int				sjis, uni;
	char			str1[8], str2[8];
	unsigned char	map[MAPSIZE];
	FILE			*fp;

	/*		INIT MAP		*/
	for (i = 0; i < MAPSIZE; i++) {
		map[i] = 0x00;
	}

	/*		MAKE MAP	*/
	fp = fopen("map.txt", "r");
	while (!feof(fp)) {
		fscanf(fp, "%s %s", str1, str2);
		sjis = hex2digit(str1);
		sjis -= (sjis >= 0xE000) ? 0xC100 : 0x8100;
		uni  = hex2digit(str2);
		map[sjis * 2]		= (uni >> 8) & 0xFF;
		map[sjis * 2 + 1]	= uni & 0xFF;
	}
	fclose(fp);

	/*		SAVE MAP	*/
	fp = fopen("sj2utf.bin", "wb");
	fwrite(map, sizeof(char), MAPSIZE, fp);
	fclose(fp);

	/*		COMVINE FILES	*/
	system("copy /B sj2utf.txt + sj2utf.bin sj2utf.pl");

	return 0;
}
